# -*- coding: utf-8 -*-
import socket
import Queue
#from constants import SOCKET_QUEUE_SIZE
from libs import citrusleaf


def create_conn_queue(ip, port, count, user=None, password=None):

    #q = Queue.Queue(maxsize=MAX_CONNECTIONS_PER_NODE)
    #q = Queue.Queue(maxsize=SOCKET_QUEUE_SIZE)
    q = Queue.Queue(maxsize=count)
    for i in range(count):
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        sock.settimeout(5)
        #try:
        sock.connect((ip, int(port)))
        if user is not None:
            citrusleaf.authenticate(sock, user, password)
        q.put(sock)
        #except:
        #    raise Exception('Unable to create socket')
    return q


def create_socket(ip, port, user=None, password=None):

    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    sock.settimeout(5)
    try:
        sock.connect((ip, int(port)))
        if user is not None:
            citrusleaf.authenticate(sock, user, password)
        return sock
    except:
        return None


def close_sockets_in_queue(q):

    while not q.empty():
        sock = q.get()
        sock.close()